package com.tfg.andreu.biblioteca.test;
//@Autor: Andreu Querol Salsench
// Llicencia: Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons

import android.support.test.espresso.intent.rule.IntentsTestRule;
import android.support.test.filters.LargeTest;
import android.support.test.runner.AndroidJUnit4;

import com.tfg.andreu.biblioteca.BuscadorLlibres;
import com.tfg.andreu.biblioteca.R;

import org.junit.Rule;
import org.junit.Test;
import org.junit.runner.RunWith;

import static android.support.test.espresso.Espresso.onData;
import static android.support.test.espresso.Espresso.onView;
import static android.support.test.espresso.action.ViewActions.click;
import static android.support.test.espresso.action.ViewActions.closeSoftKeyboard;
import static android.support.test.espresso.action.ViewActions.typeText;
import static android.support.test.espresso.intent.Intents.intended;
import static android.support.test.espresso.intent.matcher.BundleMatchers.hasEntry;
import static android.support.test.espresso.intent.matcher.IntentMatchers.hasExtras;
import static android.support.test.espresso.intent.matcher.IntentMatchers.toPackage;
import static android.support.test.espresso.matcher.ViewMatchers.withId;
import static org.hamcrest.Matchers.allOf;
import static org.hamcrest.Matchers.equalTo;
import static org.hamcrest.Matchers.instanceOf;
import static org.hamcrest.Matchers.is;

@LargeTest
@RunWith(AndroidJUnit4.class)
public class testParametresCerca {

    @Rule
    public IntentsTestRule <BuscadorLlibres> buscadorLlibres =
            new IntentsTestRule<>(BuscadorLlibres.class);

    @Test
    public void verificarParametresCerca(){

        //Introduim que volem buscar la paraula clau informatica al editText paraulesClau
        onView(withId(R.id.paraulesClau)).perform(typeText("informatica"),closeSoftKeyboard());

        onView(withId(R.id.llista_temes)).perform(click());
        onData(allOf(is(instanceOf(String.class)))).atPosition(1).perform(click());


        //Fem click al boto de Buscar
        onView(withId(R.id.bt_fes_cerca)).perform(click());

        //Comprovem que al Cataleg de llibres s'ha rebut les paraules clau indicades
         intended(allOf(
                 hasExtras(allOf(
                         hasEntry(equalTo("tema"), equalTo("Informatica"))
                         ,hasEntry(equalTo("paraulesClau"), equalTo("informatica"))))
                 ,toPackage("com.tfg.andreu.biblioteca")));
    }
}
