package com.tfg.andreu.biblioteca;
//@Autor: Andreu Querol Salsench
// Llicencia: Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
import android.Manifest;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.graphics.Color;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.loopj.android.http.AsyncHttpClient;
import com.loopj.android.http.AsyncHttpResponseHandler;
import com.loopj.android.http.RequestParams;

import org.json.JSONObject;

import java.util.ArrayList;

import cz.msebera.android.httpclient.Header;

//Activitat que s'encarrega de l'acció de reservar un llibre per a un usuari
public class FerReserva extends AppCompatActivity {

    private ProgressDialog dialegProgres;
    private TextView reservaOK;
    private TextView infoDataRecollida;
    private TextView dataRecollida;
    private TextView dataTornada;
    private Button bt_LlistaReserves;

    //Menu de navegació
    private ListView lv_llista_menu;
    private DrawerLayout drawer_menu_navegacio;
    private ActionBarDrawerToggle drawerToggle;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_reserva);
        getSupportActionBar().setTitle("Reserva");//Indiquem que estem a la activitat per a fer una reserva

         /*En cas que el servidor no sigui instantani reservant el llibre es mostra un missatge a l'usuari indicant que s'esta treballant en la seva petició*/
        dialegProgres = new ProgressDialog(FerReserva.this);
        dialegProgres.setMessage("Obtenint informació...");
        dialegProgres.setCancelable(false);

        reservaOK = (TextView) findViewById(R.id.reserva_OK);
        bt_LlistaReserves = (Button) findViewById(R.id.bt_llista_reserves);

        //Es recolleixen els parametres rebuts
        Bundle parametres = getIntent().getExtras();
        String dataMaximaReserva = "";
        String idLlibre ="";
        SharedPreferences sp= getSharedPreferences("Login",0);
        String idUsuari  = sp.getString("idUsuari",null);

        //Si no hi ha un usuari logejat al dispositiu error
        if(idUsuari == null || idUsuari.equals("-1")){
            Toast.makeText(getApplicationContext(), "Error. Usuari no ingresat al sistema", Toast.LENGTH_LONG).show();
            finish();
        }
        else {
            //Si rebem parametres ->
            if (parametres != null) {

                infoDataRecollida = (TextView) findViewById(R.id.reserva_info_recollida);
                dataRecollida = (TextView) findViewById(R.id.reserva_data_recollida);
                dataTornada = (TextView) findViewById(R.id.reserva_data_tornada);

                dataMaximaReserva = parametres.getString("DataMaximaReserva");
                idLlibre = parametres.getString("idLlibre");

                //Si no tenim un idLlibre el qual reservar ->
                if (idLlibre == null) {
                    infoDataRecollida.setVisibility(View.INVISIBLE);
                    dataRecollida.setVisibility(View.INVISIBLE);
                    reservaOK.setText("ERROR: El llibre no s'ha pogut reservar");
                    reservaOK.setTextColor(Color.RED);
                }//Si tenim un idLlibre valid -->
                else {

                    RequestParams params = new RequestParams();
                    params.put("idLlibre", idLlibre);
                    params.put("idUsuari", idUsuari);
                    invocarServidorFerReserva(params);
                }
            }//Si no rebem parametres -->
            else {
                infoDataRecollida.setVisibility(View.INVISIBLE);
                dataRecollida.setVisibility(View.INVISIBLE);
                reservaOK.setText("ERROR: El llibre no s'ha pogut reservar");
                reservaOK.setTextColor(Color.RED);
            }
            //Comportament del boto per accedir a la llista de reserves de l'usuari
            bt_LlistaReserves.setOnClickListener(new View.OnClickListener() {

                @Override
                public void onClick(View v) {

                    SharedPreferences sp = getSharedPreferences("Login", 0);
                    String idUsuari = sp.getString("idUsuari", null);
                    //Si no hi ha usuari logejat --> redirigim a login
                    if (idUsuari == null || idUsuari.equals("-1")) {

                        startActivity(new Intent(FerReserva.this, Login.class));
                    }
                    //Si hi ha un usuari logejat, redirigim al llistat de reserves
                    else {

                        startActivity(new Intent(FerReserva.this, LlistaReserves.class));
                    }
                }
            });
        }
    }

    private void invocarServidorFerReserva(RequestParams params){

        dialegProgres.show();

        AsyncHttpClient client = new AsyncHttpClient();
        client.get(getString(R.string.domini_servidor)+"/biblioteca/reservarLlibre/reserva",params ,new AsyncHttpResponseHandler() {

            /*S'executa el metode onSuccess si la resposta rebuda conte el codi de resposta Http 200*/
            @Override
            public void onSuccess(int statusCode, Header[] headers, byte[] response) {

                dialegProgres.hide();

                try {
                    //Obtenim la resposta del servidor
                    JSONObject resultatReservaJSON = new JSONObject(new String(response, "UTF-8"));
                    Boolean resultatReserva = resultatReservaJSON.getBoolean("reservaOK");
                    String resultatDataTornada = resultatReservaJSON.getString("dataTornada");
                    String resultatDataRecollida = resultatReservaJSON.getString("dataRecollida");

                    //Si s'ha pogut reservar el llibre amb exit, i no hi ha una data de recollida que mostrar ->
                    //(Vol dir que l'usuari es el primer en reservar el llibre i per tant com no hi ha una data de tornada d'un altre usuari pot anar a recollir-lo quan vulgui)
                    if(resultatReserva==true && resultatDataRecollida.equals("")){

                        infoDataRecollida.setVisibility(View.INVISIBLE);
                        dataRecollida.setVisibility(View.INVISIBLE);
                        dataTornada.setText(resultatDataTornada);
                    }
                    //Si s'ha pogut reservar el llibre amb exit, i s'ha rebut una data de recollida, es mostra juntament amb la data de tornada
                    //(Vol dir que l'usuari esta a la cua de reserves del llibre, la data de recollida es igual a la data de tornada del ultim usuari de la cua avans d`'afegir el nou usuari).
                    else if (resultatReserva==true && !resultatDataRecollida.equals("")){
                        infoDataRecollida.setVisibility(View.VISIBLE);
                        dataRecollida.setVisibility(View.VISIBLE);
                        dataRecollida.setText(resultatDataRecollida);
                        dataTornada.setText(resultatDataTornada);

                    }//En qualsevol altre cas, resultatReserva==false i per tant es mostra un error conforme no s'ha pogut reservar el llibre
                    else{
                        infoDataRecollida.setVisibility(View.INVISIBLE);
                        dataRecollida.setVisibility(View.INVISIBLE);
                        reservaOK.setText("ERROR: El llibre no s'ha pogut reservar");
                        reservaOK.setTextColor(Color.RED);
                    }



                }catch (Exception e){
                    Log.d("Error","Error en la resposta del servidor (El JSON rebut del servidor pot ser invalid?");
                    e.printStackTrace();
                }

            }

            /*Si la resposta del servidor NO conte el codi Http de resposta 200 s'executa el metode onFailure*/
            @Override
            public void onFailure(int statusCode, Header[] headers, byte[] errorResponse, Throwable e) {

                dialegProgres.hide();
                reservaOK.setText("ERROR: El llibre no s'ha pogut reservar");
                reservaOK.setTextColor(Color.RED);
                //Depenent del codi de resposta d'error indiquem un missatge o un altre

                if(statusCode == 500){
                    Toast.makeText(getApplicationContext(), "500. Error del servidor", Toast.LENGTH_LONG).show();

                }
                else if(statusCode == 404){
                    Toast.makeText(getApplicationContext(), "404. Recurs no trobat", Toast.LENGTH_LONG).show();
                }
                else{
                    Toast.makeText(getApplicationContext(), "Dispositiu sense connexió o servidor no disponible", Toast.LENGTH_LONG).show();
                }
            }
        });

    }

    ///////////////////////////////////////
    //CONFIGURACIÓ DEL MENU DE NAVEGACIÓ///
    ///////////////////////////////////////

    //Executem la creació del menu onStart per si un usuari logeja al telefon actualitzar el menu i mostrar la opció d'anar al llistat de llibres en prestec
    @Override
    protected void onStart() {
        super.onStart();

        SharedPreferences sp= getSharedPreferences("Login",0);
        String idUsuari  = sp.getString("idUsuari",null);

        //Si no hi ha un usuari logejat al dispositiu error
        if(idUsuari == null || idUsuari.equals("-1")){
            Toast.makeText(getApplicationContext(), "Error. Usuari no ingresat al sistema", Toast.LENGTH_LONG).show();
            finish();
        }
        //Passem el idUsuari com a parametre ja que no cal accedir a les sharedPreferences dos vegades un cop a onStart i un altre dintre de afegirMenuNavegacio()
        afegirMenuNavegacio(idUsuari); //Metode que configura el menu de navegació

    }

    private void afegirMenuNavegacio(String idUsuari){

        lv_llista_menu = (ListView)findViewById(R.id.lv_llista_menu);
        drawer_menu_navegacio = (DrawerLayout)findViewById(R.id.drawer_menu_navegacio);

        //Afegim les opcions al menu i el click listener

        ArrayList<String> llistaOpcionsMenu = new ArrayList<String>();

        if(idUsuari == null || idUsuari.equals("-1")){
            llistaOpcionsMenu.add("Inici");
            llistaOpcionsMenu.add("Buscador de llibres");
            llistaOpcionsMenu.add("Escanejar codi QR");
        }
        else{
            llistaOpcionsMenu.add("Inici");
            llistaOpcionsMenu.add("Buscador de llibres");
            llistaOpcionsMenu.add("Escanejar codi QR");
            llistaOpcionsMenu.add("Llibres en prestec");
        }

        lv_llista_menu.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, llistaOpcionsMenu));

        lv_llista_menu.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                if(id==0){
                    //Si seleccionem la opció per anar a l'inici
                    startActivity(new Intent(FerReserva.this,Home.class));
                    finish();//Eliminem la activitat per  no permetre tornar a aquesta activitat amb el boto cap endarrere
                }
                else if(id==1){
                    //Si seleccionem la opció per anar al buscador de llibres
                    startActivity(new Intent(FerReserva.this,BuscadorLlibres.class));
                    finish();//Eliminem la activitat per  no permetre tornar a aquesta activitat amb el boto cap endarrere
                }
                else if(id==2){
                    //Si seleccionem la opció per escanejar un codi QR

                    //Comprovem que tinguem permisos per accedir a la camera, si no els tenim els demanem
                    if (ContextCompat.checkSelfPermission(FerReserva.this, Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED) {

                        ActivityCompat.requestPermissions(FerReserva.this, new String[]{Manifest.permission.CAMERA},1);
                    }
                    //Si ja tenim permisos anem directament al lector QR
                    else{
                        startActivity(new Intent(FerReserva.this,InstruccionsQR.class));
                        finish();//Eliminem la activitat per  no permetre tornar a aquesta activitat amb el boto cap endarrere
                    }
                }
                else if(id==3){
                    //Si seleccionem la opció per mostrar els llibres en prestec de l'usuari
                    startActivity(new Intent(FerReserva.this,LlistaReserves.class));
                    finish();//Eliminem la activitat per  no permetre tornar a aquesta activitat amb el boto cap endarrere
                }
            }
        });

        drawerToggle = new ActionBarDrawerToggle(this, drawer_menu_navegacio, R.string.menu_navegacio_obert, R.string.menu_navegacio_tancat) {

            /** Quan el menu esta obert per complert canviem el titol de la activitat */
            public void onDrawerOpened(View drawerView) {
                super.onDrawerOpened(drawerView);
                getSupportActionBar().setTitle("Navegador");
                invalidateOptionsMenu();
            }

            /** Quan el menu esta tancat per complert canviem el titol de la activitat */
            public void onDrawerClosed(View view) {
                super.onDrawerClosed(view);
                getSupportActionBar().setTitle("Reserva");
                invalidateOptionsMenu();
            }
        };

        drawerToggle.setDrawerIndicatorEnabled(true);
        drawer_menu_navegacio.addDrawerListener(drawerToggle);

        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setHomeButtonEnabled(true);
    }

    //Per a evitar que el menu no estigui sincronitzat cridrem syncState
    @Override
    protected void onPostCreate(Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);
        drawerToggle.syncState();
    }

    //Per a evitar que el menu no estigui sincronitzat quan per exemple passem de orientacio vertical a horitzontal cridem onConfigurationChanged
    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        drawerToggle.onConfigurationChanged(newConfig);
    }

    //Metodes que crea el menu de la part superior dreta, on es pot accedir a fer el login/logout
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_usuari, menu);

        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        int itemSeleccionat = item.getItemId();

        if(itemSeleccionat == R.id.menu_detalls_usuari){

            SharedPreferences sp= getSharedPreferences("Login",0);
            String idUsuari  = sp.getString("idUsuari",null);

            if(idUsuari == null || idUsuari.equals("-1")){
                startActivity(new Intent(FerReserva.this,Login.class));
            }
            else{
                startActivity(new Intent(FerReserva.this,InfoUsuari.class));
            }
            return true;
        }
        if (drawerToggle.onOptionsItemSelected(item)) {
            return true;
        }
        return super.onOptionsItemSelected(item);

    }


    //Metode que s'executa quan l'usuari respon a la otorgació o denegació de permisos
    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        switch (requestCode) {
            case 1: {
                //Si l'usuari ha donat permisos obrim el lector QR
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                    startActivity(new Intent(FerReserva.this,InstruccionsQR.class));

                } else {
                    //En cas contrari mostrem un missatge informant que la opció no esta habilitada
                    Toast.makeText(getApplicationContext(), "S'ha denegat el permis per accedir a la camera", Toast.LENGTH_LONG).show();
                }
            }
        }
    }

}
