package com.tfg.andreu.biblioteca;
//@Autor: Andreu Querol Salsench
// Llicencia: Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
import org.json.JSONException;
import org.json.JSONObject;

//Clase Java encarregada de contenir la informació d'un llibre del sistema.
public class Llibre {

    private int id;
    private String titol;
    private String autor;
    private String dataPublicacio;
    private String imatge;
    private String descripcio;
    private String tema;

    public Llibre(int id, String titol, String autor, String dataPublicacio, String imatge, String descripcio, String tema)
    {
        this.id=id;
        this.titol=titol;
        this.autor=autor;
        this.dataPublicacio=dataPublicacio;
        this.imatge=imatge;
        this.descripcio=descripcio;
        this.tema=tema;

    }
   //Te un constructor amb un parametre JSONObject per comoditat
    public Llibre (JSONObject llibreEnJson){
        try{
            id = llibreEnJson.getInt("id");
            titol = llibreEnJson.getString("titol");
            autor = llibreEnJson.getString("autor");
            dataPublicacio = llibreEnJson.getString("dataPublicacio");
            imatge = llibreEnJson.getString("imatge");
            descripcio = llibreEnJson.getString("descripcio");
            tema = llibreEnJson.getString("tema");

        }catch(JSONException e){
            e.printStackTrace();
        }
    }

    public int getId(){
        return id;
    }

    public String getTitol(){
        return titol;
    }

    public String getAutor(){
        return autor;
    }

    public String getDataPublicacio(){
        return dataPublicacio;
    }

    public String getImatge(){
        return imatge;
    }

    public String getDescripcio(){
        return descripcio;
    }

    public String getTema(){
        return tema;
    }

    public void setId(int id){
        this.id=id;
    }

    public void setTitol(String titol){
        this.titol=titol;
    }

    public void setAutor(String autor){
        this.autor=autor;
    }

    public void setDataPublicacio( String dataPublicacio){
        this.dataPublicacio=dataPublicacio;
    }

    public void setImatge (String imatge){
        this.imatge=imatge;
    }

    //Metode que retorna la informació del llibre en format JSON
    public JSONObject llibreToJson(){

        JSONObject ret = new JSONObject();

        try{
            ret.put("id",this.getId());
            ret.put("titol",this.getTitol());
            ret.put("autor",this.getAutor());
            ret.put("dataPublicacio",this.getDataPublicacio());
            ret.put("imatge",this.getImatge());
            ret.put("descripcio",this.getDescripcio());
            ret.put("tema",this.getTema());

        }   catch(JSONException e){
            e.printStackTrace();
        }
        return ret;
    }
}
