package com.tfg.andreu.biblioteca;
//@Autor: Andreu Querol Salsench
// Llicencia: Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons

import org.json.JSONException;
import org.json.JSONObject;

//Classe Java que conte la informació d'una reserva
public class Reserva {

    private int idLlibre;
    private String titolLlibre;
    private String dataRecollida;
    private String dataTornada;
    private Boolean recordatori;
    private String imatge;
    private int numAmpliacions;

    public Reserva(int idLlibre, String titolLlibre, String dataRecollida, String dataTornada, Boolean recordatori, String imatge, int numAmpliacions){
        this.idLlibre=idLlibre;
        this.titolLlibre=titolLlibre;
        this.dataRecollida=dataRecollida;
        this.dataTornada=dataTornada;
        this.recordatori=recordatori;
        this.imatge=imatge;
        this.numAmpliacions=numAmpliacions;
    }

    //Disposa d'un constructor JSON per comoditat
    public Reserva(JSONObject infoJSON){
        try{

            idLlibre = infoJSON.getInt("idLlibre");
            titolLlibre = infoJSON.getString("titol");
            dataRecollida = infoJSON.getString("dataRecollida");
            dataTornada = infoJSON.getString("dataTornada");
            recordatori = infoJSON.getBoolean("recordatori");
            imatge = infoJSON.getString("imatge");
            numAmpliacions = infoJSON.getInt("numAmpliacions");
        }catch(JSONException e){
            e.printStackTrace();
        }
    }

    public int getIdLlibre(){
        return idLlibre;
    }
    public String getTitolLlibre(){
        return titolLlibre;
    }
    public String getDataRecollida(){
        return dataRecollida;
    }
    public String getDataTornada(){
        return dataTornada;
    }
    public Boolean getRecordatori(){
        return recordatori;
    }
    public String getImatge(){
        return imatge;
    }
    public int getNumAmpliacions() { return numAmpliacions;}

    public void setIdLlibre(int idLlibre){
        this.idLlibre=idLlibre;
    }

    public void setTitolLlibre(String titolLlibre){
        this.titolLlibre=titolLlibre;
    }

    public void setDataRecollida(String dataRecollida){
        this.dataRecollida=dataRecollida;
    }

    public void setDataTornada(String dataTornada){
        this.dataTornada=dataTornada;
    }

    public void setRecordatori(Boolean recordatori){
        this.recordatori=recordatori;
    }

    public void setImatge(String imatge){
        this.imatge=imatge;
    }

    public void setNumAmpliacions( int numAmpliacions){this.numAmpliacions=numAmpliacions;}
}
