package com.tfg.andreu.bibliotecari;
//@Autor: Andreu Querol Salsench
// Llicencia: Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
import android.Manifest;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;


public class Home extends AppCompatActivity {

    private Button bt_prestar_llibre;
    private Button bt_tornar_llibre;
    private Button bt_alta_usuari;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_home);
        getSupportActionBar().setTitle("Inici");//Indiquem que estem a la activitat inicial de l'aplicació


        bt_prestar_llibre = (Button) findViewById(R.id.bt_prestar_llibre);
        bt_tornar_llibre = (Button) findViewById(R.id.bt_tornar_llibre);
        bt_alta_usuari = (Button) findViewById(R.id.bt_alta_usuari);

        /*Afegim el listener al boto per donar d'alta un usuari, tornar i prestar llibres*/
        bt_alta_usuari.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                startActivity(new Intent(Home.this,RegistrarUsuari.class));
            }
        });


        bt_tornar_llibre.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                //Comprovem que tinguem permisos per accedir a la camera, si no els tenim els demanem
                if (ContextCompat.checkSelfPermission(Home.this, Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED) {

                    ActivityCompat.requestPermissions(Home.this, new String[]{Manifest.permission.CAMERA},1);
                }
                //Si ja tenim permisos anem directament al lector QR
                else{
                    startActivity(new Intent(Home.this,TornarLlibreQR.class));
                }
            }
        });

        bt_prestar_llibre.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                //Comprovem que tinguem permisos per accedir a la camera, si no els tenim els demanem
                if (ContextCompat.checkSelfPermission(Home.this, Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED) {

                    ActivityCompat.requestPermissions(Home.this, new String[]{Manifest.permission.CAMERA},1);
                }
                //Si ja tenim permisos anem directament al lector QR
                else{
                    startActivity(new Intent(Home.this,PrestarLlibreUsuari.class));
                }
            }
        });
    }

    //Metode que s'executa quan l'usuari respon a la otorgació o denegació de permisos
    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        switch (requestCode) {
            case 1: {
                //Si l'usuari ha donat permisos indiquem que el lector esta habilitat
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                    Toast.makeText(getApplicationContext(), "Lector QR habilitat", Toast.LENGTH_LONG).show();
                } else {
                    //En cas contrari deshabilitem els botons
                    bt_tornar_llibre.setEnabled(false);
                    bt_prestar_llibre.setEnabled(false);
                }
                return;
            }
        }
    }
}