package com.tfg.andreu.bibliotecari;
//@Autor: Andreu Querol Salsench
// Llicencia: Aquesta obra està subjecta a una llicència de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons
import android.app.ProgressDialog;
import android.graphics.Color;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;
import android.widget.ViewFlipper;

import com.loopj.android.http.AsyncHttpClient;
import com.loopj.android.http.AsyncHttpResponseHandler;
import com.loopj.android.http.RequestParams;

import org.json.JSONObject;

import cz.msebera.android.httpclient.Header;

public class RegistrarUsuari extends AppCompatActivity {

    private ViewFlipper flipper;
    private ProgressDialog dialegProgres;

    //Camps de registre
    private EditText DNI;
    private EditText nom_real;
    private EditText poblacio;
    private EditText carrer;
    private EditText email;
    private EditText nomUsuari;
    private EditText password;

    //Bottons "Següent"
    private Button bt1;
    private Button bt2;
    private Button bt3;
    private Button bt4;

    //Botons "Anterior"
    private Button bt_anterior2;
    private Button bt_anterior3;
    private Button bt_anterior4;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_registrar_usuari);
        getSupportActionBar().setTitle("Registrar un usuari");//Indiquem que estem a la activitat per a registrar un usuari

        /*Inicialitzem els objectes de les vistes*/
        flipper = (ViewFlipper) findViewById(R.id.flipper_registrar);

        DNI = (EditText) findViewById(R.id.DNI);
        nom_real = (EditText) findViewById(R.id.nom_real);
        poblacio = (EditText) findViewById(R.id.poblacio);
        carrer = (EditText) findViewById(R.id.carrer);
        email = (EditText) findViewById(R.id.email);
        nomUsuari = (EditText) findViewById(R.id.nomUsuari);
        password = (EditText) findViewById(R.id.password);

        bt1 = (Button) findViewById(R.id.bt_registrar1);
        bt2 = (Button) findViewById(R.id.bt_registrar2);
        bt3 = (Button) findViewById(R.id.bt_registrar3);
        bt4 = (Button) findViewById(R.id.bt_registrar4);
        bt_anterior2 = (Button) findViewById(R.id.bt_anterior2);
        bt_anterior3 = (Button) findViewById(R.id.bt_anterior3);
        bt_anterior4 = (Button) findViewById(R.id.bt_anterior4);


        //Listeners dels diferents bottons

        //Es realitzen comprovacions per a la primera pantalla
        bt1.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if(DNI.length()!=9){
                    Toast.makeText(getApplicationContext(), "DNI incorrecte", Toast.LENGTH_LONG).show();
                }
                else if(nom_real.length()==0){
                    Toast.makeText(getApplicationContext(), "S'ha d'introduir el nom i cognoms de l'usuari", Toast.LENGTH_LONG).show();
                }
                else {//Si tenim dades introduides comprovem que el DNI no estigui ja introduit al sistema

                     /*En cas que el servidor no sigui instantani retornant les dades es mostra un missatge a l'usuari indicant que s'esta treballant en la seva petició*/
                    dialegProgres = new ProgressDialog(RegistrarUsuari.this);
                    dialegProgres.setMessage("Comprovant DNI...");
                    dialegProgres.setCancelable(false);



                    RequestParams params = new RequestParams();
                    params.put("dni", DNI.getText().toString().toUpperCase());
                    invocarServidorComprovarDNI(params);
                }
            }
        });

        //Es realitzen comprovacions per a la segona pantalla
        bt2.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if(poblacio.length()==0){
                    Toast.makeText(getApplicationContext(), "S'ha d'introduir el nom de la poblacio", Toast.LENGTH_LONG).show();
                }
                else if(carrer.length()==0){
                    Toast.makeText(getApplicationContext(), "S'ha d'introduir el nom del carrer", Toast.LENGTH_LONG).show();
                }
                else {
                    flipper.showNext();
                }
            }
        });

        //Es realitzen comprovacions per a la tercera pantalla
        bt3.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {


                if(nomUsuari.length()==0){
                    Toast.makeText(getApplicationContext(), "S'ha d'introduir el nom d'usuari", Toast.LENGTH_LONG).show();
                }
                else if(email.length()==0){
                    Toast.makeText(getApplicationContext(), "S'ha d'introduir el email de l'usuari", Toast.LENGTH_LONG).show();
                }
                else {//Si tenim dades introduides comprovem que el nom d'usuari estigui disponible

                     /*En cas que el servidor no sigui instantani retornant les dades es mostra un missatge a l'usuari indicant que s'esta treballant en la seva petició*/
                    dialegProgres = new ProgressDialog(RegistrarUsuari.this);
                    dialegProgres.setMessage("Comprovant nom d'usuari...");
                    dialegProgres.setCancelable(false);

                    RequestParams params = new RequestParams();
                    params.put("nomUsuari", nomUsuari.getText());
                    invocarServidorComprovarNomUsuari(params);
                }




            }
        });

        //Es realitzen comprovacions per a la quarta pantalla
        bt4.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                if(password.length()==0){
                    Toast.makeText(getApplicationContext(), "S'ha d'introduir una contrasenya", Toast.LENGTH_LONG).show();
                }
                else if(password.length()<4){
                    Toast.makeText(getApplicationContext(), "La contrasenya és massa curta", Toast.LENGTH_LONG).show();
                }
                else {
                    dialegProgres = new ProgressDialog(RegistrarUsuari.this);
                    dialegProgres.setMessage("Creant usuari...");
                    dialegProgres.setCancelable(false);

                    RequestParams params = new RequestParams();

                    params.put("DNI", DNI.getText().toString().toUpperCase());
                    params.put("nomReal", nom_real.getText());
                    params.put("poblacio", poblacio.getText());
                    params.put("carrer", carrer.getText());
                    params.put("email", email.getText());
                    params.put("nomUsuari", nomUsuari.getText());
                    params.put("password", password.getText());

                    invocarServidorRegistrarUsuari(params);
                }



            }
        });

        //Utilitzem el mateix listener per a tots els botons "Anterior"
        View.OnClickListener listenerAnterior = new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                flipper.showPrevious();
            }
        };

        bt_anterior2.setOnClickListener(listenerAnterior);
        bt_anterior3.setOnClickListener(listenerAnterior);
        bt_anterior4.setOnClickListener(listenerAnterior);

    }

    //Metode que comprova al servidor si el nom d'usuari indicat esta disponible
    private void invocarServidorComprovarDNI(RequestParams params){

        dialegProgres.show();

        AsyncHttpClient client = new AsyncHttpClient();
        client.get(getString(R.string.domini_servidor)+"/biblioteca/bibliotecariDNI/comprovarDNI",params ,new AsyncHttpResponseHandler() {

            /*S'executa el metode onSuccess si la resposta rebuda conte el codi de resposta Http 200*/
            @Override
            public void onSuccess(int statusCode, Header[] headers, byte[] response) {

                dialegProgres.hide();
                try {
                    //Si el servidor retorna true la operacio es correcta en cas contrari retorna false
                    Boolean resultatOK = new JSONObject(new String(response, "UTF-8")).getBoolean("resultatOK");

                    if(resultatOK==true){
                        Toast.makeText(getApplicationContext(), "DNI correcte", Toast.LENGTH_LONG).show();
                        DNI.setTextColor(Color.BLACK);
                        flipper.showNext();
                    }
                    else
                    {
                        Toast.makeText(getApplicationContext(), "Error, aquest DNI ja s'ha utilitzat amb un altre usuari", Toast.LENGTH_LONG).show();
                        DNI.setTextColor(Color.RED);
                    }

                }catch (Exception e){
                    Log.d("Error","Error en la resposta del servidor (El JSON rebut del servidor pot ser invalid?");
                    e.printStackTrace();
                }
            }

            /*Si la resposta del servidor NO conte el codi Http de resposta 200 s'executa el metode onFailure*/
            @Override
            public void onFailure(int statusCode, Header[] headers, byte[] errorResponse, Throwable e) {

                dialegProgres.hide();
                //Depenent del codi de resposta d'error indiquem un missatge o un altre

                if(statusCode == 500){
                    Toast.makeText(getApplicationContext(), "500. Error del servidor", Toast.LENGTH_LONG).show();
                }
                else if(statusCode == 404){
                    Toast.makeText(getApplicationContext(), "404. Recurs no trobat", Toast.LENGTH_LONG).show();
                }
                else{
                    Toast.makeText(getApplicationContext(), "Dispositiu sense connexió o servidor no disponible", Toast.LENGTH_LONG).show();
                }
            }
        });
    }


    //Metode que comprova al servidor si el nom d'usuari indicat esta disponible
    private void invocarServidorComprovarNomUsuari(RequestParams params){

        dialegProgres.show();

        AsyncHttpClient client = new AsyncHttpClient();
        client.get(getString(R.string.domini_servidor)+"/biblioteca/bibliotecariNU/comprovarNomUsuari",params ,new AsyncHttpResponseHandler() {

            /*S'executa el metode onSuccess si la resposta rebuda conte el codi de resposta Http 200*/
            @Override
            public void onSuccess(int statusCode, Header[] headers, byte[] response) {

                dialegProgres.hide();
                try {
                    //Si el servidor retorna true la operacio es correcta en cas contrari retorna false
                    Boolean resultatOK = new JSONObject(new String(response, "UTF-8")).getBoolean("resultatOK");

                    if(resultatOK==true){
                        Toast.makeText(getApplicationContext(), "Nom d'usuari correcte", Toast.LENGTH_LONG).show();
                        nomUsuari.setTextColor(Color.BLACK);
                        flipper.showNext();
                    }
                    else
                    {
                        Toast.makeText(getApplicationContext(), "Error, aquest nom d'usuari no esta disponible", Toast.LENGTH_LONG).show();
                        nomUsuari.setTextColor(Color.RED);
                    }

                }catch (Exception e){
                    Log.d("Error","Error en la resposta del servidor (El JSON rebut del servidor pot ser invalid?");
                    e.printStackTrace();
                }
            }

            /*Si la resposta del servidor NO conte el codi Http de resposta 200 s'executa el metode onFailure*/
            @Override
            public void onFailure(int statusCode, Header[] headers, byte[] errorResponse, Throwable e) {

                dialegProgres.hide();
                //Depenent del codi de resposta d'error indiquem un missatge o un altre

                if(statusCode == 500){
                    Toast.makeText(getApplicationContext(), "500. Error del servidor", Toast.LENGTH_LONG).show();
                }
                else if(statusCode == 404){
                    Toast.makeText(getApplicationContext(), "404. Recurs no trobat", Toast.LENGTH_LONG).show();
                }
                else{
                    Toast.makeText(getApplicationContext(), "Dispositiu sense connexió o servidor no disponible", Toast.LENGTH_LONG).show();
                }
            }
        });
    }

    //Metode que registra un usuari al sistema
    private void invocarServidorRegistrarUsuari(RequestParams params){

        dialegProgres.show();

        AsyncHttpClient client = new AsyncHttpClient();
        client.get(getString(R.string.domini_servidor)+"/biblioteca/bibliotecariCU/CrearUsuari",params ,new AsyncHttpResponseHandler() {

            /*S'executa el metode onSuccess si la resposta rebuda conte el codi de resposta Http 200*/
            @Override
            public void onSuccess(int statusCode, Header[] headers, byte[] response) {

                dialegProgres.hide();
                try {

                    //Si el servidor retorna true la operacio es correcta en cas contrari retorna false
                    Boolean resultatOK = new JSONObject(new String(response, "UTF-8")).getBoolean("resultatOK");

                    if(resultatOK==true){
                        Toast.makeText(getApplicationContext(), "Usuari creat correctament", Toast.LENGTH_LONG).show();
                        finish();
                    }
                    else
                    {
                        Toast.makeText(getApplicationContext(), "Error al crear l'usuari", Toast.LENGTH_LONG).show();
                    }

                }catch (Exception e){
                    Log.d("Error","Error en la resposta del servidor (El JSON rebut del servidor pot ser invalid?");
                    e.printStackTrace();
                }
            }

            /*Si la resposta del servidor NO conte el codi Http de resposta 200 s'executa el metode onFailure*/
            @Override
            public void onFailure(int statusCode, Header[] headers, byte[] errorResponse, Throwable e) {

                dialegProgres.hide();
                //Depenent del codi de resposta d'error indiquem un missatge o un altre

                if(statusCode == 500){
                    Toast.makeText(getApplicationContext(), "500. Error del servidor", Toast.LENGTH_LONG).show();
                }
                else if(statusCode == 404){
                    Toast.makeText(getApplicationContext(), "404. Recurs no trobat", Toast.LENGTH_LONG).show();
                }
                else{
                    Toast.makeText(getApplicationContext(), "Dispositiu sense connexió o servidor no disponible", Toast.LENGTH_LONG).show();
                }
            }
        });
    }
}