package com.biblioteca.jersey;

//@Autor: Andreu Querol Salsench
//Llicencia: Aquesta obra est subjecta a una llicncia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;
//Classe que proporciona la funcionalitat per a retornar una llista de llibres filtrats per unes paraules clau i un tema
@Path("/cerca")
public class CercaLlibres {
	
    @GET
    @Path("/fescercallista")
    @Produces(MediaType.APPLICATION_JSON) 
 
    //http://localhost:8080/biblioteca/cerca/fescercallista?paraulesClau=Nom del llibre&tema=Informatica
   
    public String cercaLlista(@QueryParam("paraulesClau") String paraulesClau, @QueryParam("tema") String tema){
       
    	String resposta = "";
        try{
    		resposta = ConnexioBDD.cercaLlistaLlibres(paraulesClau, tema);

    	}catch(Exception e){
    		e.printStackTrace();
    		System.out.println("Cerca llibres Exception");
    	}
        
    
        return resposta;
 
    }
    
    
  /*  Metode per fer una cerca simple d'un unic llibre,*/
    @GET
    @Path("/fescercasimple")  
    //http://localhost:8080/biblioteca/cerca/fescercasimple?id=1
    @Produces(MediaType.APPLICATION_JSON)
    public String cercaUnLlibre(@QueryParam("idLlibre") String idLlibre){
        
    	String resposta = "";
        
        try{
    		resposta = ConnexioBDD.cercaUnLlibre(idLlibre);

    	}catch(Exception e){
    		e.printStackTrace();
    	}
       
        return resposta;
    }
   
}

