package com.biblioteca.jersey;

//@Autor: Andreu Querol Salsench
//Llicencia: Aquesta obra est subjecta a una llicncia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

//Classe que proporciona acces al servei per comprovar si el nom d'usuari introduit per el bibliotecari es valid a l'hora de crear un nou usuari
@Path("/bibliotecariNU")
public class ComprovarNomUsuari {
	@GET 
    @Path("/comprovarNomUsuari")
    @Produces(MediaType.APPLICATION_JSON) 
    //http://localhost:8080/biblioteca/bibliotecari/comprovarNomUsuari?nomUsuari=aquerol
    
    public String comprovarNomUsuari(@QueryParam("nomUsuari") String nomUsuari){
        String resposta="";

        //Si obtenim parametres valids executem la petici a la base de dades
        if(ConversorsJSON.stringNotNull(nomUsuari)){
            
        	try {       	
                resposta = ConnexioBDD.comprovarNomUsuariOK(nomUsuari);         
                
            } catch (Exception e) {
                e.printStackTrace();
                
            }
        
        }
        //tornem la reposta utilitzant un String amb format JSON o be "" si els parametres no son correctes.
        
        return resposta;
    } 
}
