package com.biblioteca.jersey;

//@Autor: Andreu Querol Salsench
//Llicencia: Aquesta obra est subjecta a una llicncia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
 
public class ConnexioBDD {
    
	/*	Metode per a obrir una connexio amb la base de dades MySQL
		Retorna una connexi amb la base de dades
			Si la connexi es correcta retorna la connexio
			Si la connexi no es correcta retorna null*/		
    @SuppressWarnings("finally")
    public static Connection obrirConnexio() throws Exception {
        Connection con = null;
        try {
        	Class.forName("com.mysql.jdbc.Driver");
            con = DriverManager.getConnection("jdbc:mysql://localhost:3306/biblioteca", "root", "Xancla90");
        } catch (Exception e) {
            throw e;
        } finally {
            return con;
        }
    }
   /* 
    	Metode que realitza el login a l'aplicaci
    	Retorna un objecte Usuari en format JSON
    		Si el login es correcte l'objecte usuari conte el nom i el id de l'usuari
    		Si el login no es correcte l'objecte usuari conte el nom="" i el id=-1
    */
    public static String login(String usuari, String password) throws Exception {
        
    	Usuari usuariRet = new Usuari();
        Connection connexioBD = null;
        
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
            String query = "SELECT id, NomUsuari FROM usuaris WHERE NomUsuari = '" +usuari+ "' AND Contrasenya=" + "'" + password + "'";
            
            ResultSet resultat = statement.executeQuery(query);
            
            if (resultat.next()) {
                usuariRet.setId(resultat.getInt(1));
                usuariRet.setNomUsuari(resultat.getString(2));
            }
        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament    
        } catch (Exception e) {
            if (connexioBD != null) {
            	connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
            	connexioBD.close();
            }
        }
        return ConversorsJSON.usuariToJSON(usuariRet).toString();
    }
   
    /*
       Metode que cerca un conjunt de llibres filtrats per les paraules clau i el tema indicats.
       Retorna un String en formt JSON amb un array de llibres
       		Si la cerca no produeix resultats retorna una llista buida
        	Si la cerca si produeix resultats retorna una llista amb els llibres en format JSON
    */    
    public static String cercaLlistaLlibres(String paraulesClau, String tema) throws Exception {
        
    	ArrayList<Llibre> llistaLlibres = new ArrayList<Llibre>();
        String query;
        Connection connexioBD = null;
        
        try
        {
            connexioBD = ConnexioBDD.obrirConnexio();

            Statement statement = connexioBD.createStatement();
          
            //Si el tema es == null busquem per paraules clau
            if(stringEsNull(tema)){
            	 
            	 query = "SELECT * FROM llibres where Titol like '%"+paraulesClau+"%'";
            }
            //Si les paraules clau == null busquem per tema
            else if (stringEsNull(paraulesClau)){
            	query = "SELECT * FROM llibres where Tema ='"+tema+"'";
            }
            //Si cap dels dos es null, busquem per paraules clau i tema
            else{
            	query = "SELECT * FROM llibres where Titol like '%"+paraulesClau+"%' and Tema ='"+tema+"'";
            }
            
            ResultSet resultat = statement.executeQuery(query);

            while(resultat.next()){
            	llistaLlibres.add(new Llibre(Integer.parseInt(resultat.getString(1)),resultat.getString(2),resultat.getString(3),resultat.getString(4),resultat.getString(5),resultat.getString(6),resultat.getString(7)));
            }
        }       
        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        catch (Exception e) 
        {
            if (connexioBD != null) 
            {
            	connexioBD.close();
            }
            throw e;
        } finally 
        {
            if (connexioBD != null) {
            	connexioBD.close();
            }
        }
        return ConversorsJSON.llistaLlibresToJSON(llistaLlibres).toString();
    }
    
   
    /*
    Metode per buscar un llibre en concret a traves del seu id
    Retorna un String en formt JSON amb el llibre
    	Si la cerca no produeix resultats retorna null
     	Si la cerca si produeix resultats retorna el llibre en format JSON
 */    
    public static String cercaUnLlibre(String idLlibre) throws Exception {
    	String ret = "";
    	Llibre llibre = null;
        
        Connection connexioBD = null;
        try {
        	 connexioBD = ConnexioBDD.obrirConnexio();

             Statement statement = connexioBD.createStatement();
            
            String query = "SELECT * FROM llibres where id="+idLlibre+"";

            ResultSet resultat = statement.executeQuery(query);
           
            if(resultat.next()){
            	llibre = new Llibre(Integer.parseInt(resultat.getString(1)),resultat.getString(2),resultat.getString(3),resultat.getString(4),resultat.getString(5),resultat.getString(6),resultat.getString(7));
            	ret = ConversorsJSON.llibreToJSON(llibre).toString();
            }
            
           
        } //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        catch (Exception e) 
        {
            if (connexioBD != null) 
            {
            	connexioBD.close();
            }
            throw e;
        } finally 
        {
            if (connexioBD != null) {
            	connexioBD.close();
            }
        }
        return ret;
    }
    
    
    /*
     * Metode per a reservar un llibre
     * retorn: False -> No s'ha pogut reservar el llibre
     * 		   True -> El llibre s'ha reservat amb exit
     * 		   data_maxima: La ultima data en la que el llibre hauria de ser retornat
     * 		   data_maxima_mes_set: La ultima data en la que el llibre hauria de ser retornat + 7 dies (es a dir la nova data en la que el llibre tornara a estar disponible)
     * */
    public static String reservarLlibre(String idUsuari, String idLlibre) throws Exception {
    	
    	String ret = ConversorsJSON.reservaOKToJSON(false,"","").toString(); //Per defecte retornarem false i sense dates

        String data_maxima = ""; 
        String data_maxima_mes_set="";
        Connection connexioBD = null;
        
        try {
            connexioBD = ConnexioBDD.obrirConnexio();
            
            Statement statement = connexioBD.createStatement();
           
           
            /*En primer lloc mirem quina es la data maxima en la que el llibre esta reservat*/
            String query = "SELECT DataRetorn FROM prestecs where DataRetorn=(SELECT MAX(DataRetorn) FROM prestecs where IdLlibre='"+idLlibre+"')";
            
            ResultSet resultat = statement.executeQuery(query);
            
            while(resultat.next()){            	
            	data_maxima = resultat.getString(1);      	
            }
            
            //Si es la primera reserva del llibre tenim que sumar +7 dies al dia actual
            if(data_maxima == null || data_maxima.equals("") || data_maxima.equals("''")){
            	query = "INSERT INTO prestecs(IdUsuari, IdLlibre, Recordatori, DataRetorn, DataRecollida, NumAmpliacions) VALUES ('"+idUsuari+"', '"+idLlibre+"', '0', DATE_ADD(CURDATE(), INTERVAL 7 DAY),CURDATE(),'0')";
            	
            }
            else//En cas que ja es tingui una o ms reserves del llibre es suma 7 dies a la data de la ultima reserva
            {
            	query = "INSERT INTO prestecs(IdUsuari, IdLlibre, Recordatori, DataRetorn, DataRecollida, NumAmpliacions) VALUES ('"+idUsuari+"', '"+idLlibre+"', '0', DATE_ADD('"+data_maxima+"', INTERVAL 7 DAY),'"+data_maxima+"','0')";
            }
            
           
            //A continuacio fem la reserva amb la data maxima calculada anteriorment +7 dies
            int resultatInsert = statement.executeUpdate(query);
            
            //En tercer lloc tormen a executar la mateixa consulta del pas 1 per a obtenir la nova data maxima i retornarla com a parametre a l'aplicacio
            
            query = "SELECT DataRetorn FROM prestecs where DataRetorn=(SELECT MAX(DataRetorn) FROM prestecs where IdLlibre='"+idLlibre+"')";
           
            resultat = statement.executeQuery(query);
            
            while(resultat.next()){
            	
            	data_maxima_mes_set = resultat.getString(1);
            	
            }
            
            //Si el insert s'ha dut a terme correctament ->
            if (resultatInsert > 0) {
                ret = ConversorsJSON.reservaOKToJSON(true,data_maxima_mes_set,data_maxima).toString();
            }
        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        //En cas que el insert no s'hagi dut a terme correctament retornem el valor per defecte (false, "","")
        return ret;
    }
    
    /*Metode que s'utilitza per retornar la informaci necessaria a l'aplicaci per tal de mostrar la informaci personalitzada sobre les reserves dels llibres
    	Retorna la llista d'usuaris que tenen reservat un llibre i les dates de les seves reserves
    		Si s'obte algun resultat a la consulta es retorna una llista d'usuaris i les dates de la seva reserva en format JSON
    		Si no s'obte cap resultat per a la consulta es retorna una llista buida i una data buida en format JSON
    		*/
    public static String infoReserva(String idLlibre) throws Exception {
    	
    	String dataReserva = "";
    	ArrayList<String> llistaUsuarisAmbReserva = new ArrayList<String>();
    	String ret = "";
    	
        Connection connexioBD = null;
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
            
            Statement statement = connexioBD.createStatement();

            /*En primer lloc mirem quina es la data maxima en la que el llibre esta reservat*/
            String query = "SELECT DataRetorn FROM prestecs where DataRetorn=(SELECT MAX(DataRetorn) FROM prestecs where IdLlibre='"+idLlibre+"')";
            
            ResultSet resultat = statement.executeQuery(query);
           
            while(resultat.next()){
            			dataReserva = resultat.getString(1);
            }
            
            //Busquem tambe quin es el llistat d'usuaris que tenen el llibre reservat per tal de mostrar adecuadament la informacio a l'aplicacio
            query = "SELECT idUsuari FROM prestecs where IdLlibre='"+idLlibre+"'";
            
            resultat = statement.executeQuery(query);
            
            while(resultat.next()){
    			llistaUsuarisAmbReserva.add(resultat.getString(1));
            }
            
            ret = ConversorsJSON.infoReservaToJSON(llistaUsuarisAmbReserva, dataReserva).toString();

        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
           
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        return ret;
    }
    
    /*Metode que s'utilitza per a retornar el llistat de reserves de l'usuari
    	Retorna un el llistat d'objectes Reserva que te fetes un usuari
    		Si l'usuari te algun llibre reservat es retorna el llistat de reserve de l'usuari en format JSON
    		Si l'usuari no te cap llibre reservar es retorna una llista buida en format JSON
    	*/
    public static String llistaReserves(String idUsuari) throws Exception {
    	
    	ArrayList<Reserva> llistaReserves = new ArrayList<Reserva>();
    	String ret = "";
    	
        Connection connexioBD = null;
        try {
            
            connexioBD = ConnexioBDD.obrirConnexio();
            
            Statement statement = connexioBD.createStatement();
           
          
            /*Obtenim tota la informacio necessaria sobre la reserva de la base de dades per tal de retornarla a l'aplicaci*/
            String query = "SELECT prestecs.IdLlibre, prestecs.Recordatori, prestecs.DataRetorn, prestecs.DataRecollida, llibres.Titol, llibres.Imatge, prestecs.NumAmpliacions FROM prestecs INNER JOIN llibres ON prestecs.IdLlibre = llibres.id where prestecs.idUsuari='"+idUsuari+"';";
            
            ResultSet resultat = statement.executeQuery(query);
           
            while(resultat.next()){
            			llistaReserves.add(new Reserva(resultat.getInt(1),resultat.getBoolean(2),resultat.getString(3),resultat.getString(4),resultat.getString(5),resultat.getString(6),resultat.getInt(7)));
            			
            }

            ret = ConversorsJSON.llistaReservesToJSON(llistaReserves).toString();
            
        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
           
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        return ret;
    }
    
    /*Metode que realitza l'ampliaci del prestec d'un llibre a un usuari
    	Retorna un Boolea indicant si s'ha realitzat l'operaci amb xit i el nombre de cops que l'usuari ha ampliat el termini de prestec del llibre
    		Si la operaci s'executa amb xit retorna (true, numero de cops que ha ampliat el termini l'usuari)
    		Si la operaci s'executa amb xit pero l'usuari ja ha ampliat el termini 3 cops retornem (false, numero de cops que ha ampliat el termini l'usuari)
    		Si la operaci no s'executa amb xit retorna (false, -1)
    */
    public static String ampliarPrestec(String idUsuari, String idLlibre) throws Exception {
    	
    	
        Connection connexioBD = null;
        try {
           
                connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
           
            /*En primer lloc mirem quants cops s'ha ampliat el plas del llibre seleccionat*/
            String query = "SELECT NumAmpliacions from prestecs where idUsuari='"+idUsuari+"' and idLlibre ='"+idLlibre+"';";
            
            ResultSet resultat = statement.executeQuery(query);       
            int numeroAmpliacions;
            
            if(resultat.next()==true){
            	
            	numeroAmpliacions = resultat.getInt(1);
            	if(numeroAmpliacions >3){
            		//Si ja s'ha ampliat el plas mes de 3 cops del llibre s'ha de tornar i no es pot ampliar mes
            		return ConversorsJSON.ampliacioToJSON(false,numeroAmpliacions).toString();
            	}
            	else{
            		/*Fem una altra consulta SQL mirant si amb un idUsuari diferent hi ha algun registre que idLlibre sigui igual, 
            		el qual voldra dir que hi ha una altra reserva d'un altre usuari al llibre i per tant no podem ampliar el temps 
            		de prestec*/
            		
            		query = "Select idUsuari from prestecs where idUsuari!='"+idUsuari+"' and idLlibre ='"+idLlibre+"';";
            		
            		resultat = statement.executeQuery(query);
            		
            		if(resultat.next()==true){
            			//El llibre esta reservat per dos usuaris diferents, no es pot ampliar el termini de reserva
            			return ConversorsJSON.ampliacioToJSON(false,numeroAmpliacions).toString();
            		}
            		else
            		{	//El llibre unicament esta reservat per un usuari i no ha ampliat el temps de reserva mes de 3 cops, per tant ampliem el temps de reserva
            			query = "update prestecs set dataRetorn=DATE_ADD(dataRetorn, INTERVAL 3 DAY), NumAmpliacions=NumAmpliacions+1 where idUsuari='"+idUsuari+"' and idLlibre='"+idLlibre+"'";
            			int ampliacioOK = statement.executeUpdate(query);
            			
            			//Si la ampliacio es du a terme correctament -->
            			if (ampliacioOK == 1){
            				return ConversorsJSON.ampliacioToJSON(true,numeroAmpliacions).toString();
            			}
            			else//Si no es du a terme correctament -->
            			{
            				return ConversorsJSON.ampliacioToJSON(false,numeroAmpliacions).toString();
            			}
            		}
            	}			
            }
            else{
            	//Error. Si entrem aqui es perque el llibre al qual volem ampliar el temps de prestec no esta a la taula de prestecs
            	return ConversorsJSON.ampliacioToJSON(false,-1).toString();
            }    
            
        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
       
    }
   
    /*Metode que realitza l'activaci o desactivaci del recordatori de devolucio d'un llibre a un usuari
    	Retorna un int en format JSON indicant el resultat de la operaci:
    		1 == Operacio OK, recordatori activat
    		0 == Operacio OK, recordatori desactivat
    		-1 == Operacio fallida*/
    public static String activarDesactivarRecordatori(String idUsuari, String idLlibre, Boolean activarDesactivar) throws Exception {
    	
    	
        Connection connexioBD = null;
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
            String query;
            
            /*En primer lloc mirem si tenim que activar o desactivar el recordatori*/
            if(activarDesactivar==true){
            	//Activem el recordatori
            	 query = "update prestecs set recordatori='1' where idUsuari='"+idUsuari+"' and idLlibre='"+idLlibre+"'";
            	
            	 int recordatoriOK = statement.executeUpdate(query);
     			
     			//Si l'activaci/desactivacio es du a terme correctament -->
     			if (recordatoriOK == 1){
     				return ConversorsJSON.activDesactivRecordatoriToJSON(1).toString();
     			}
     			else
     			{
     				return ConversorsJSON.activDesactivRecordatoriToJSON(-1).toString();
     			}

            }
            else{
            	//Desactivem el recordatori
            	 query = "update prestecs set recordatori='0' where idUsuari='"+idUsuari+"' and idLlibre='"+idLlibre+"'";
            	 
            	 int recordatoriOK = statement.executeUpdate(query);
     			
     			//Si l'activaci/desactivacio es du a terme correctament -->
     			if (recordatoriOK == 1){
     				return ConversorsJSON.activDesactivRecordatoriToJSON(0).toString();
     			}
     			else
     			{
     				return ConversorsJSON.activDesactivRecordatoriToJSON(-1).toString();
     			}
            }

        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
    }
    
    /*Metode que obte la informaci dels recordatoris de retorn de llibres d'un usuari
    	Retorna una llista de objectes recordatori en format JSON:
    		"" == error al executar la operacio
    		llistaRecordatoris si es buida vol dir que no s'ha trobat cap recordatori*/
    public static String infoRecordatoriRetorn(String idUsuari) throws Exception {
    	
    	ArrayList<Recordatori> llistaRecordatoris = new ArrayList<Recordatori>();
        Connection connexioBD = null;
        String ret="";
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
            String query = "SELECT prestecs.DataRetorn, llibres.Titol FROM prestecs INNER JOIN llibres ON prestecs.IdLlibre = llibres.id where prestecs.idUsuari='"+idUsuari+"' and prestecs.Recordatori='1' and prestecs.DataRetorn between CURDATE() and DATE_ADD(CURDATE(), INTERVAL 2 DAY)";
            
            ResultSet resultat = statement.executeQuery(query);
            
            while(resultat.next()){
            	llistaRecordatoris.add(new Recordatori(resultat.getString(1),resultat.getString(2)));	
            }
            
            ret= ConversorsJSON.llistaRecordatorisToJSON(llistaRecordatoris).toString();

        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        return ret;
    }
    
    /*Metode que obt la informaci dels recordatoris de recollida de llibres d'un usuari
    	Retorna una llista de objectes Recordatori en format JSON
    		"" == error al executar la operacio
    		llistaRecordatoris si es buida vol dir que no s'ha trobat cap llibre que l'usuari pugui recollir amb data d'avui*/
    public static String infoRecordatoriRecollida(String idUsuari) throws Exception {
    	
    	ArrayList<Recordatori> llistaRecordatoris = new ArrayList<Recordatori>();
        Connection connexioBD = null;
        String ret="";
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
            //Unicament volem els llibres que no estan actualment en prestec (prestat=0)
            String query = "SELECT prestecs.DataRecollida, llibres.Titol FROM prestecs INNER JOIN llibres ON prestecs.IdLlibre = llibres.id where prestecs.idUsuari='"+idUsuari+"' and prestecs.prestat='0' and prestecs.DataRecollida <= CURDATE()";
            
            ResultSet resultat = statement.executeQuery(query);
            
            while(resultat.next()){
            	llistaRecordatoris.add(new Recordatori(resultat.getString(1),resultat.getString(2)));	
            }
            
            ret= ConversorsJSON.llistaRecordatorisToJSON(llistaRecordatoris).toString();

        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        return ret;
    }
    
    //Metode auxiliar que serveix per comprovar si les String pasades per parametre son null
    	//Retorna true si la string es null
    	//Retorna false si la string NO es null
    private static boolean stringEsNull (String text){
    	
    	if (text != null && text.trim().length() > 0){
    		return false;
    	}
    	else
    	{
    		return true;
    	}
    }
    
  /*Metode que comprova si el DNI passat per parametre no esta al sistema
    Retorna un Boolea en format JSON:
    	//true == El dni es correcte, es pot introduir a la base de dades
    	//false == El dni es incorrecte o ja existeix a la base de dades, no es pot introduir*/
    public static String comprovarDNIOK(String dni) throws Exception {
    	
        Connection connexioBD = null;
        String ret= ConversorsJSON.resultatOKToJSON(false).toString();	
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
            String query = "SELECT DNI FROM usuaris where DNI='"+dni+"'";
            
            ResultSet resultat = statement.executeQuery(query);
            
            if(resultat.next()==false){//No s'ha trobat el DNI a la base de dades per tant retornem true
            	ret = ConversorsJSON.resultatOKToJSON(true).toString();	
            }

        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        
        return ret;
    }
    
  /*Metode que comprova si el usuari passat per parametre no esta al sistema
    Retorna un boolea en format JSON:
    	true == El nom d'usuari es correcte, es pot introduir a la base de dades
    	false == El nom d'usuari es incorrecte o ja existeix a la base de dades, no es pot introduir*/
    public static String comprovarNomUsuariOK(String nomUsuari) throws Exception {
    	
        Connection connexioBD = null;
        String ret= ConversorsJSON.resultatOKToJSON(false).toString();	
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
            String query = "SELECT NomUsuari FROM usuaris where NomUsuari='"+nomUsuari+"'";
            
            ResultSet resultat = statement.executeQuery(query);
            
            if(resultat.next()==false){//No s'ha trobat el nom d'usuari a la base de dades per tant retornem true
            	ret = ConversorsJSON.resultatOKToJSON(true).toString();	
            }

        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        return ret;
    }
    
  /*Metode que crea un nou usuari al sistema
    Retornorna un boolea en format JSON:
    	true == L'usuari s'ha creat correctament
    	false == L'usuari no s'ha creat correctament*/
    public static String crearUsuari(String dni, String nomReal, String poblacio, String carrer, String email, String nomUsuari, String password) throws Exception {
    	
        Connection connexioBD = null;
        String ret=ConversorsJSON.resultatOKToJSON(false).toString();	
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
            String query = "INSERT INTO usuaris (DNI, NomReal, Contrasenya, Email, Carrer, NomUsuari, Poblacio) VALUES ('"+dni+"', '"+nomReal+"', '"+password+"', '"+email+"', '"+carrer+"', '"+nomUsuari+"', '"+poblacio+"');";
            
            int creacioOK = statement.executeUpdate(query);
 			
 			//Si la creaci de l'usuari es du a terme correctament -->
 			if (creacioOK == 1){
 				ret= ConversorsJSON.resultatOKToJSON(true).toString();	
 			}
 			else
 			{
 				ret= ConversorsJSON.resultatOKToJSON(false).toString();	
 			}

        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        return ret;
    }
    
    /*Metode que retorna un llibre que ha estat prestat
    	Retorna un boolea en format JSON:
    		true == El retorn s'ha realitzat correctament
    		false ==  El retorn no s'ha realitzat correctament*/
    public static String tornarLlibre(String idLlibre) throws Exception {
    	
        Connection connexioBD = null;
        String ret=ConversorsJSON.resultatOKToJSON(false).toString();	
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
            String query = "DELETE FROM prestecs WHERE IdLlibre='"+idLlibre+"' ORDER BY DataRetorn ASC LIMIT 1;";

            int resultatOK = statement.executeUpdate(query);
 			
 			//Si la devoluci del llibre es du a terme correctament -->
 			if (resultatOK == 1){
 				ret= ConversorsJSON.resultatOKToJSON(true).toString();
 				
 				//Actualitzem la data de recollida del seguent usuari esperant a la cua de reserves per a poder informar que el llibre ja esta retornat i pot recollirlo amb data d'avui
 				query = "update prestecs set DataRecollida=CURDATE() where idLlibre='"+idLlibre+"' ORDER BY DataRetorn ASC LIMIT 1;";
 				//En aquest cas no es comprova el resultat de la operacio perque si retorna 0 simplement vol dir que no hi ha cap usuari esperant a que es retorni el llibre
 				statement.executeUpdate(query);			 						
 			}
 			else
 			{
 				ret= ConversorsJSON.resultatOKToJSON(false).toString();	
 			}

        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        return ret;
    }
    
    /*Metode que presta un llibre de la biblioteca a un usuari
      Retorna un boolea en format JSON:
      		true == El prestec s'ha realitzat correctament
    		false ==  El prestec no s'ha realitzat correctament*/
    public static String prestarLlibre(String idLlibre, String nomUsuari) throws Exception {
    	
        Connection connexioBD = null;
        String ret=ConversorsJSON.resultatOKToJSON(false).toString();	
        try {
           
            connexioBD = ConnexioBDD.obrirConnexio();
           
            Statement statement = connexioBD.createStatement();
            //En primer lloc comprovem que l'usuari tingui dret a emportar-se el llibre (que no s'estigui colant a la cua de reserves)
            
            String query ="select usuaris.NomUsuari from usuaris INNER JOIN prestecs ON usuaris.id = prestecs.IdUsuari where prestecs.idLlibre='"+idLlibre+"' ORDER BY prestecs.DataRecollida ASC LIMIT 1";
          
            ResultSet resultat = statement.executeQuery(query);
            
            if(resultat.next())//Si hi ha almenys un usuari a la llista de reserves del llibre es comprova que s'estigui prestant el llibre a l'usuari correcte
            {
            	if(!resultat.getString(1).equals(nomUsuari)){//Si l'usuari indicat no es el primer de la llista de reserves retornem error
            		
            		ret=ConversorsJSON.resultatOKToJSON(false).toString();	
            	}
            	else{//En cas contrari si l'usuari es el primer de la llista de reserves vol dir que podem prestar el llibre sense problema
            		
            		query = "update prestecs set Prestat='1' WHERE IdLlibre='"+idLlibre+"' ORDER BY DataRecollida ASC LIMIT 1;";

                    int resultatOK = statement.executeUpdate(query);
         			
         			//Si el prestec del llibre es du a terme correctament -->
         			if (resultatOK == 1){
         				ret= ConversorsJSON.resultatOKToJSON(true).toString();						
         			} 			
         			else//Si no es pot realitzar el prestec -->
         			{
         				ret= ConversorsJSON.resultatOKToJSON(false).toString();	
         			}
            	}
            
            }
            else//Si no hi ha cap usuari a la llista de reserves del llibre es reserva i presta tal i com es faria amb l'aplicaci android
            {
            	
            	//En primer lloc obtenim el idUsuari
            	query = "select id from usuaris where NomUsuari='"+nomUsuari+"'";
            	resultat = statement.executeQuery(query);
                
                if(resultat.next())//Si el nom d'usuari es valid primer fem una reserva en nom de l'usuari i a continuaci prestem el llibre
                {
                	reservarLlibre(resultat.getString(1),idLlibre);
                	
                	query = "update prestecs set Prestat='1' WHERE IdLlibre='"+idLlibre+"' ORDER BY DataRecollida ASC LIMIT 1;";

                    int resultatOK = statement.executeUpdate(query);
         			
         			//Si el prestec del llibre es du a terme correctament -->
         			if (resultatOK == 1){
         				ret= ConversorsJSON.resultatOKToJSON(true).toString();						
         			} 			
         			else//Si no es pot realitzar el prestec -->
         			{
         				ret= ConversorsJSON.resultatOKToJSON(false).toString();	
         			}
                	
                }
                else//Si el nom d'usuari no es valid error
                {
                	ret= ConversorsJSON.resultatOKToJSON(false).toString();	
                }
            }
        //Ens asegurem de tancar la connexio amb la base de dades si alguna cosa surt malament
        } catch (Exception e) {
            
            if (connexioBD != null) {
                connexioBD.close();
            }
            throw e;
        } finally {
            if (connexioBD != null) {
                connexioBD.close();
            }
        }
        return ret;
    }
}