package com.biblioteca.jersey;

//@Autor: Andreu Querol Salsench
//Llicencia: Aquesta obra est subjecta a una llicncia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

//Classe que s'utilitza per obtenir el llistat de reserves que te l'usuari
@Path("/reservesUsuari")
public class LlistaReserves {
	
    @GET
    @Path("/obtenirLlista")
    @Produces(MediaType.APPLICATION_JSON) 
    // Query parameters are parameters: http://localhost:8080/biblioteca/reservesUsuari/obtenirLlista?idUsuari=1
    public String llistaReserves(@QueryParam("idUsuari") String idUsuari){
        String resposta="";

        if(ConversorsJSON.stringNotNull(idUsuari)){
            
        	try {       	
                resposta = ConnexioBDD.llistaReserves(idUsuari);         
                
            } catch (Exception e) {
                e.printStackTrace();
            }        
        }    
        return resposta;
    }

}


