package com.biblioteca.jersey;

//@Autor: Andreu Querol Salsench
//Llicencia: Aquesta obra est subjecta a una llicncia de Reconeixement-NoComercial-SenseObraDerivada 3.0 Espanya de Creative Commons

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

//Aquesta classe proporciona la funcionalitat per a poder reservar un llibre del cataleg
@Path("/reservarLlibre")
public class ReservarLlibre {
    @GET
    @Path("/reserva")  
    @Produces(MediaType.APPLICATION_JSON) 
    //http://localhost:8080/biblioteca/reservarLlibre/reserva?idUsuari=1&idLlibre=1
    public String reservaLlibre(@QueryParam("idUsuari") String idUsuari, @QueryParam("idLlibre") String idLlibre){
        String resposta="";
        
        if(ConversorsJSON.stringNotNull(idUsuari) && ConversorsJSON.stringNotNull(idLlibre)){
            
        	try {        		
                resposta = ConnexioBDD.reservarLlibre(idUsuari, idLlibre);   
            } catch (Exception e) {
                e.printStackTrace();
                
                //Tot i que ja esta controlat a nivell de base de dades,
                //Si hi ha algun problema amb la reserva retornem false per indicar que no s'ha pogut realitzat
                resposta = ConversorsJSON.reservaOKToJSON(false,"","").toString();
            }
        
        }
        
        return resposta;
    }
}